/*
 * CVisualization.java
 *
 * Created on July 15, 2007, 7:07 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package collision.test;

import java.awt.*;
import collision.*;
import java.util.List;

/**
 *
 * @author ask
 */
public class CVisualization {
    
    CollisionDetector cd;
    
    /** Creates a new instance of CVisualization */
    public CVisualization(CollisionDetector cd){
        this.cd = cd;
    }
        
    public void draw(Graphics g, int width, int height){
        g.setColor(Color.black);
        int xSize = width/cd.width;
        int ySize = height/cd.height;
        for(int i = 0; i < cd.width; i++){
            for(int j = 0; j < cd.width; j++){
                int x = i*width/cd.width;
                int y = j*height/cd.height;
                //g.setColor(Color.GRAY);
                //g.fillRect(x, y, xSize, ySize); //fill
                g.setColor(Color.black);
                g.drawRect(x, y, xSize, ySize); //edge
            }
        }
        
        for(int i = 0; i < cd.width; i++){
            for(int j = 0; j < cd.height; j++){
                int x = i*width/cd.width;
                int y = j*height/cd.height;
                g.setColor(Color.black);
                g.drawString(""+cd.getTile(i,j).getColliderCount(), x+2, y+12);                
                Tile t = cd.getTile(i,j);
                
                for(Collider c : t.getColliders()){
                    int cx = c.getX() * width / cd.xPoints;
                    int cy = c.getY() * height / cd.yPoints;
                    int radius = c.getRadius() * width / cd.xPoints;
                    Color color = c.checkCollide() ? Color.red : Color.blue;
                    g.setColor(color);
                    g.fillOval(cx-radius, cy-radius, 2*radius, 2*radius);
                }
            }
        }

    }    
}
