/*
 * Main.java
 *
 * Created on July 11, 2007, 10:52 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package collision.test;

import collision.*;
import java.util.Random;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 *
 * @author ask
 */
public class Main extends JFrame {
    
    public final int width = 6, height = 6, resolution=128;
    CollisionDetector cd = new CollisionDetector(width, height, 128);
    
    CVisualization vis = new CVisualization(cd);
    //public final int bigWidth = width*resolution, bigHeight = height*resolution;
    
    public final Random rand = new Random(0);
    final Collider[] colliders = new Collider[20];
    final JPanel panel;
    
    /** Creates a new instance of Main */
    public Main() {
        super("Collision detector test program");
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        
        for(int i = 0; i < colliders.length; i++){
            Collider c = cd.makeCollider(resolution/4);
            colliders[i] = c;
        }
                
        JPanel container = new JPanel();
        container.setLayout(new BorderLayout());
        
        panel = new JPanel(){
            protected void paintComponent(Graphics g){
                super.paintComponent(g);
                //draw grid
                int width = getWidth();
                int height = getHeight();
                vis.draw(g, width, height);
            }
        
        };
        panel.setPreferredSize(new Dimension(512, 512));

        setRandomPositions();        
        
        JButton button = new JButton("Move");
        container.add(button, BorderLayout.NORTH);
        button.addActionListener(new ActionListener(){
            
           public void actionPerformed(ActionEvent e){
               setRandomPositions();
           } 
        });        
        
        container.add(panel, BorderLayout.CENTER);
        add(container);
        pack();
    }
    
    public void setRandomPositions(){
       for(Collider c : colliders){
            int newX = rand.nextInt(cd.xPoints);
            int newY = rand.nextInt(cd.yPoints);
            if(c.isOnBoard()){
                c.move(newX, newY);
            } else { //offboard
                c.set(newX, newY);
                c.register();
            }
            panel.repaint();
        }        
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Main().setVisible(true);
    }
    
}
